<h1>CBNet: Cooperation-Based Weakly Supervised Polyp Detection</h1>

---
PyTorch implementation of "CBNet: Cooperation-Based Weakly Supervised Polyp Detection" (CBNet).

![framework.png](framework.png)
<h2>Requirements</h2>

___
<li>numpy==1.21.6</li>
<li>Pillow==9.0.1</li>
<li>torchvision==0.12.0</li>
<li>tqdm==4.64.0</li>
<li>torch==1.11.0</li>
<h2>Get started</h2>

___
<h3>Start</h3>
cd code
<h3>Download Datasets</h3>

[CVC-ClinicDB] (https://polyp.grand-challenge.org/CVCClinicDB/)

[Kvasir] (https://datasets.simula.no/downloads/kvasir-seg.zip)
```
data
  ├─clinicdb
  │  ├─images
  │  │   ├─*.png or *.jpg
     ├─labels
  │  │   ├─*.xml
  │  ├─test_samAndssw.txt
  │  └─test_samFilterAndssw.txt
  ├─kvasir
  │  ├─***
  │  └─***
  └─private
      ├─***
      └─***
```
<h3>Download our pretrained checkpoint</h3>
[pth] (链接：https://pan.baidu.com/s/1p3y8J3EmYu09VXwQFEnKUg?pwd=bak7 提取码：bak7)
```
code
  ├─params
```
<h3>Test</h3>
python test.py 

The testing results will be displayed as:
```
class   confidence   top    left    right    bottom
Pedicle  0.9996209   95.0   117.0   152.0    170.0
```
